package com.bipt.intelligentapplicationorchestrationservice.pojo;

import lombok.Data;

import java.io.Serializable;

/**
 * 后端统一返回结果
 * @author hky
 * @param <T>
 */
@Data
public class OptResult<T> implements Serializable {

    private boolean isSuccess;
    private String errorInfo;
    private int statusCode;
    private T data;

    public static <T> OptResult<T> success() {
        OptResult<T> result = new OptResult<>();
        result.isSuccess = true;
        return result;
    }

    public static <T> OptResult<T> success(T object) {
        OptResult<T> result = new OptResult<>();
        result.data = object;
        result.isSuccess = true;
        return result;
    }

    public static <T> OptResult<T> error(String errorInfo) {
        OptResult result = new OptResult();
        result.errorInfo = errorInfo;
        result.isSuccess = false;
        return result;
    }

}
