package com.bipt.intelligentapplicationorchestrationservice.service.Impl;

import com.bipt.intelligentapplicationorchestrationservice.mapper.DatasetMapper;
import com.bipt.intelligentapplicationorchestrationservice.pojo.*;
import com.bipt.intelligentapplicationorchestrationservice.service.DatasetService;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class DatasetServiceImpl implements DatasetService {
    @Autowired
    private DatasetMapper datasetMapper;

    /**
     * 新增数据集
     * @param datasetDTO
     */
    @Override
    public void save(DatasetDTO datasetDTO) {
        //判断数据集类型，如果是本地上传则保存，若用调用数据仓库进入下一步
        if (datasetDTO.getDatasetType()==0){
            //TODO 保存到分布式文件系统

        }else {
            Map<String,String> args = datasetDTO.getArgs();
            Integer datasetType = datasetDTO.getDatasetType();
            //TODO 根据筛选条件调用数据仓库中的数据

            //TODO 调用数据仓库保存到分布式文件系统
        }
        DatasetEntity datasetEntity = new DatasetEntity();
        BeanUtils.copyProperties(datasetEntity,datasetDTO);
        datasetEntity.setDatasetStatus(1);
        datasetEntity.setCreateTime(LocalDateTime.now());
        datasetEntity.setUpdateTime(LocalDateTime.now());
        datasetMapper.insert(datasetEntity);

    }

    /**
     * 修改数据集
     *
     * @param datasetEntity
     */
    @Override
    @Transactional
    public void update(DatasetEntity datasetEntity) {
        if (datasetEntity.getDatasetType()==0){
            //TODO 覆盖保存到分布式文件系统中

        }else {
            //TODO 覆盖数据文件


            //TODO
            datasetEntity.setUpdateTime(LocalDateTime.now());
            datasetMapper.updata(datasetEntity);
        }
    }

    /**
     * 分页查询
     * @param dataSetPageQueryDTO
     * @return
     */
    @Override
    public PageResult pageQuery(DatasetPageQueryDTO dataSetPageQueryDTO) {
        int pageNum = dataSetPageQueryDTO.getPage();
        int pageSize = dataSetPageQueryDTO.getPageSize();
        PageHelper.startPage(pageNum, pageSize);
        Page<DatasetVO> page = datasetMapper.pageQuery(dataSetPageQueryDTO);
        return new PageResult(page.getTotal(), page.getResult());
    }

    /**
     * 批量删除
     * @param datasetIds
     */
    @Override
    @Transactional
    public void deleteBatch(List<Integer> datasetIds) {
        for (Integer datasetId : datasetIds) {
            DatasetEntity datasetEntity = datasetMapper.getById(datasetId);
            if (datasetEntity == null) {
                throw new IllegalArgumentException("数据集不存在，ID：" + datasetId);
            }

        }
        //TODO 在分布式文件系统中删除

        datasetMapper.deleteBatch(datasetIds);
    }

}
